diff --git a/libswscale/riscv/input_rvv.S b/libswscale/riscv/input_rvv.S
index 1d7de59c66..d07db43b55 100644
--- a/libswscale/riscv/input_rvv.S
+++ b/libswscale/riscv/input_rvv.S
@@ -26,7 +26,7 @@ func ff_bgr24ToY_rvv, zve32x
         j       1f
 endfunc
 
-func ff_rgb24ToY_rvv, zve32x
+func ff_rgb24ToY_rvv, zve32x, zba
         lw      t1, 0(a5) # RY
         lw      t3, 8(a5) # BY
 1:
@@ -62,7 +62,7 @@ func ff_bgr24ToUV_rvv, zve32x
         j       1f
 endfunc
 
-func ff_rgb24ToUV_rvv, zve32x
+func ff_rgb24ToUV_rvv, zve32x, zba
         lw      t1, 12(a6) # RU
         lw      t4, 24(a6) # RV
         lw      t3, 20(a6) # BU
@@ -108,7 +108,7 @@ func ff_bgr24ToUV_half_rvv, zve32x
         j       1f
 endfunc
 
-func ff_rgb24ToUV_half_rvv, zve32x
+func ff_rgb24ToUV_half_rvv, zve32x, zba
         lw      t1, 12(a6) # RU
         lw      t4, 24(a6) # RV
         lw      t3, 20(a6) # BU
@@ -157,7 +157,7 @@ func ff_\chr1\()ToY_rvv, zve32x
         j       1f
 endfunc
 
-func ff_\chr0\()ToY_rvv, zve32x
+func ff_\chr0\()ToY_rvv, zve32x, zba
         lw      t1, 0(a5) # RY
         lw      t3, 8(a5) # BY
 1:
@@ -199,7 +199,7 @@ func ff_\chr1\()ToUV_rvv, zve32x
         j       1f
 endfunc
 
-func ff_\chr0\()ToUV_rvv, zve32x
+func ff_\chr0\()ToUV_rvv, zve32x, zba
         lw      t1, 12(a6) # RU
         lw      t4, 24(a6) # RV
         lw      t3, 20(a6) # BU
@@ -251,7 +251,7 @@ func ff_\chr1\()ToUV_half_rvv, zve32x
         j       1f
 endfunc
 
-func ff_\chr0\()ToUV_half_rvv, zve32x
+func ff_\chr0\()ToUV_half_rvv, zve32x, zba
         lw      t1, 12(a6) # RU
         lw      t4, 24(a6) # RV
         lw      t3, 20(a6) # BU
diff --git a/libswscale/riscv/range_rvv.S b/libswscale/riscv/range_rvv.S
index 9da80e6199..19a74eba79 100644
--- a/libswscale/riscv/range_rvv.S
+++ b/libswscale/riscv/range_rvv.S
@@ -20,7 +20,7 @@
 
 #include "libavutil/riscv/asm.S"
 
-func ff_range_lum_to_jpeg_16_rvv, zve32x
+func ff_range_lum_to_jpeg_16_rvv, zve32x, zba
         li       t1, 30189
         li       t2, 19077
         li       t3, -39057361
@@ -41,7 +41,7 @@ func ff_range_lum_to_jpeg_16_rvv, zve32x
         ret
 endfunc
 
-func ff_range_lum_from_jpeg_16_rvv, zve32x
+func ff_range_lum_from_jpeg_16_rvv, zve32x, zba
         li       t1, 14071
         li       t2, 33561947
 1:
@@ -60,7 +60,7 @@ func ff_range_lum_from_jpeg_16_rvv, zve32x
         ret
 endfunc
 
-func ff_range_chr_to_jpeg_16_rvv, zve32x
+func ff_range_chr_to_jpeg_16_rvv, zve32x, zba
         li      t1, 30775
         li      t2, 4663
         li      t3, -9289992
@@ -88,7 +88,7 @@ func ff_range_chr_to_jpeg_16_rvv, zve32x
         ret
 endfunc
 
-func ff_range_chr_from_jpeg_16_rvv, zve32x
+func ff_range_chr_from_jpeg_16_rvv, zve32x, zba
         li      t1, 1799
         li      t2, 4081085
 1:
diff --git a/libswscale/riscv/rgb2rgb_rvb.S b/libswscale/riscv/rgb2rgb_rvb.S
index af127b32ed..d18e5ba01b 100644
--- a/libswscale/riscv/rgb2rgb_rvb.S
+++ b/libswscale/riscv/rgb2rgb_rvb.S
@@ -23,7 +23,7 @@
 #include "libavutil/riscv/bswap_rvb.S"
 
 #if (__riscv_xlen >= 64)
-func ff_shuffle_bytes_3210_rvb, zbb
+func ff_shuffle_bytes_3210_rvb, zba, zbb
         srli    a2, a2, 2
         bswap32_rvb a1, a0, a2
 endfunc
diff --git a/libswscale/riscv/rgb2rgb_rvv.S b/libswscale/riscv/rgb2rgb_rvv.S
index 19f7aaf67d..e1270ac0df 100644
--- a/libswscale/riscv/rgb2rgb_rvv.S
+++ b/libswscale/riscv/rgb2rgb_rvv.S
@@ -25,7 +25,7 @@ func ff_shuffle_bytes_0321_rvv, zve32x
         j       1f
 endfunc
 
-func ff_shuffle_bytes_2103_rvv, zve32x
+func ff_shuffle_bytes_2103_rvv, zve32x, zba
         li      t1, ~0x00ff00ff
 1:
         not     t2, t1
@@ -54,7 +54,7 @@ func ff_shuffle_bytes_1230_rvv, zve32x
         j       3f
 endfunc
 
-func ff_shuffle_bytes_3012_rvv, zve32x
+func ff_shuffle_bytes_3012_rvv, zve32x, zba
         li      t1, 8
         li      t2, 24
 3:
@@ -74,7 +74,7 @@ func ff_shuffle_bytes_3012_rvv, zve32x
         ret
 endfunc
 
-func ff_interleave_bytes_rvv, zve32x
+func ff_interleave_bytes_rvv, zve32x, zba
 1:
         mv      t0, a0
         mv      t1, a1
@@ -100,7 +100,7 @@ func ff_interleave_bytes_rvv, zve32x
         ret
 endfunc
 
-func ff_deinterleave_bytes_rvv, zve32x
+func ff_deinterleave_bytes_rvv, zve32x, zba
 1:
         mv      t0, a0
         mv      t1, a1
@@ -165,10 +165,10 @@ endfunc
         ret
 .endm
 
-func ff_uyvytoyuv422_rvv, zve32x, zbb
+func ff_uyvytoyuv422_rvv, zve32x, b
         yuy2_to_i422p v20, v16
 endfunc
 
-func ff_yuyvtoyuv422_rvv, zve32x, zbb
+func ff_yuyvtoyuv422_rvv, zve32x, b
         yuy2_to_i422p v16, v20
 endfunc